package com.jeeplus.modules.sg.project.web;

import com.jeeplus.common.json.AjaxJson;
import com.jeeplus.common.utils.DateUtils;
import com.jeeplus.common.utils.StringUtils;
import com.jeeplus.core.web.BaseController;
import com.jeeplus.modules.sg.overheadline.entity.JkxlDetailFee;
import com.jeeplus.modules.sg.overheadline.service.OverheadLineService;
import com.jeeplus.modules.sg.project.entity.WbsItem;
import com.jeeplus.modules.sg.project.entity.WbsProject;
import com.jeeplus.modules.sg.project.entity.WbsSelection;
import com.jeeplus.modules.sg.project.service.ProjectService;
import com.jeeplus.modules.sg.project.util.ExportUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.servlet.mvc.support.RedirectAttributes;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.text.SimpleDateFormat;
import java.util.*;


@Controller
@RequestMapping("${adminPath}/project/tem")
public class ProjectTemController extends BaseController {
    @Autowired
    private HttpServletRequest request;
    @Autowired
    private ProjectService projectService;
    @Autowired
    private OverheadLineService overheadLineService;



    @RequestMapping("/index")
    public String toIndex(){
        return "/modules/sg/project/addItem2Form";
    }




    @RequestMapping(value = {"list", ""})
    public String list(WbsSelection wbsSelection, HttpServletRequest request, HttpServletResponse response, Model model) {
       List<WbsProject> list =  projectService.findList(wbsSelection);
       model.addAttribute("list",list);
        return "modules/sg/project/manageList";
    }



    /**
     *数据导入
     */
    @RequestMapping("/import")
    public String importFile(MultipartFile file, RedirectAttributes redirectAttributes, HttpServletRequest request, Model model) {
        String projectName = request.getParameter("projectName");     //项目名称
        String itemName = request.getParameter("itemName");     //项目名称
        String type = request.getParameter("type");     //工程类型
        String id = getId();
        WbsProject wbsProject = new WbsProject();
        wbsProject.setProjectName(projectName);
        projectService.save(wbsProject);
        List<WbsProject> wbsProjects = projectService.findByName(projectName);
        WbsProject wbsProject1 = wbsProjects.get(0);
        String projectId = wbsProject1.getId();
        try {
//            保存数据到数据库
            if(type.equals("1")) {
                overheadLineService.saveJk(file,itemName, id, projectId, type);
            }
            if (type.equals("2")) {
                overheadLineService.saveDl(file,itemName, id, projectId, type);
            }
        } catch (RuntimeException e) {
            addMessage(redirectAttributes, "导入失败,"+e.getMessage());
            return "redirect:/a/project/tem/index";
        }   catch (Exception e){
            addMessage(redirectAttributes, "导入失败");
            return "redirect:/a/project/tem/index";
        }
        addMessage(redirectAttributes, "导入成功");
        return "redirect:/a/project/tem/list?projectId="+projectId;
    }


    /**
     * 返回
     * @param request
     * @return
     */
    @RequestMapping(value = "tolist")
    public String toList(HttpServletRequest request){
        String projectId = request.getParameter("projectId");
        return "redirect:/a/project/tem/list?projectId="+projectId;
    }





    /**
     * 创建项目ID
     */
    public String getId() {
        SimpleDateFormat sdf=new SimpleDateFormat("yyyyMMddHHmmss");
        String newDate=sdf.format(new Date());
        String result="";
        Random random=new Random();
        for(int i=0;i<3;i++){
            result+=random.nextInt(10);
        }
        return newDate+result;
    }

}
